package WebFlow.FileBrowser;

import WebFlow.Core.event.*;
import WebFlow.Core.*;
import java.util.*;
import java.io.*;
import java.net.*;
import org.omg.CORBA.*;

public class FileBrowserImp extends WebFlow.Core.BeanContextChildSupport
    implements FileBrowserOperations {
    
    String msg_;
    org.omg.CORBA.Object peer;
    WFFileDescriptor outFile;

    private final String STDEXTNS[] = {"html", "htm", "jpg", "txt", "doc", "ppt"};
    
    public FileBrowserImp(org.omg.CORBA.Object peer, String msg)
	throws WebFlow.Core.NullPointerException
    {
	super(peer);	
	msg_ = msg;
	this.peer = peer;
	outFile = new WFFileDescriptorImp(getBeanContextChildPeer());
    }
    
    public void setFileName(String dirName) {
	String newmessage = dirName;
	
	outFile.setFileAttribute("default");   
	outFile.setFileHost("local");    
	
	System.out.println("FileBrowser: create outFile with " + newmessage);
	int  idx = newmessage.lastIndexOf(File.separator);
	outFile.setFileName(newmessage.substring(idx + 1));
	System.out.println("FileBrowser: file name " + outFile.getFileName());
	outFile.setFileDirectory(newmessage.substring(0, idx + 1));
	System.out.println("FileBrowser: directory " + outFile.getFileDirectory());
	System.out.println("FileBrowser:send outFile with " + outFile.getFileName());
	//send through output Port
	fireEvent("Event101", outFile);
    }
    
    public String[] refreshDirectory(String dirName)
    {
	System.out.println("refreshDirectory is CALLED with:" + dirName);
	String[] directory_contents = null;
	try{
	    directory_contents = list(dirName, "");
	}catch(InterruptedException e){
	    System.out.println("InterruptedException in list of directory content:"+e);
	}
	return  directory_contents;
    }
    
    public   String [] list(String dir, String opts)
	throws InterruptedException
    {
	String[] FileList, returnValue;
	Vector lines = new Vector();
	lines.addElement(dir);
	
	File file = new File(dir);
	
	if(file.exists()) {
	    if(file.isDirectory()) {
		if(file.canRead()) {
		    FileList = file.list();
		    lines.addElement("total xx");
		    for(int ifile = 0; ifile < FileList.length; ifile++) {
			if((new File(dir, FileList[ifile])).isDirectory()) {
			    lines.addElement("<DIR> "+FileList[ifile]);
			}
			else {
			    lines.addElement(FileList[ifile]);
			}
		    }
		}
		else {
		    System.out.println(dir+" is not readable");
		    lines.addElement("total xx");
		    lines.addElement(dir + " is not readable");
		}
	    }
	    else {
		System.err.println(dir+" is not a directory");
		lines.addElement("total xx");
		lines.addElement(dir + "is not a directory");
	    }
	} 
	else {
	    System.err.println("directory "+dir+" does not exists");
	    lines.addElement("total xx");
	    lines.addElement(dir + "does not exists");
	}
	
	returnValue = new String[lines.size()];
	lines.copyInto(returnValue);
	return returnValue;	
    }
    
    public void stop() {
	System.out.println("FileBrowserImp: Stop called");
    }

    public void run() {
	System.out.println("FileBrowserImp: Run called");
    }
    
    public void test() {
	System.out.println("FileBrowser OK");
    } 
    
    private boolean standardExtension(String filename) {
	for(int i = 0; i < STDEXTNS.length; ++i) {
	    int index = filename.lastIndexOf('.');
	    if(index >= 0 && filename.substring(index + 1).equals(STDEXTNS[i]))
	       return true;
	}
	return false;
    }
    
    public void copyFile(String source, org.omg.CORBA.StringHolder aDest) {
	
	int c;
	String dest;
	if(standardExtension(aDest.value))
	    dest = aDest.value;
	else
	    dest = aDest.value + ".txt";
	System.out.println("start copy file");
	try {
	    FileReader freader = new FileReader(source);
	    FileWriter fwriter = new FileWriter(dest);
	    System.out.println("reader and writer created");
	    while((c = freader.read()) != -1) 
		fwriter.write(c);
	    freader.close();
	    fwriter.close();   
	} catch (Exception e1) {System.out.println(e1);}
	System.out.println("file has been copied");
	aDest.value = dest;
    }
    
    public String getFileSeparator() { return File.separator; };
}




